package rene.gui;

import java.awt.*;
import java.awt.event.*;

/**
A text Button with a midifyable Font. The button
may also be triggered by a keyboard return.
<P>
This button class is used in DoActionListener interfaces.
*/

public class ButtonAction extends Button
    implements KeyListener
{   DoActionListener C;
    String Name;
    public ButtonAction (DoActionListener c, String s, String name)
    {   super(s);
        C=c; Name=name;
        addActionListener(new ActionTranslator(c,name));
        addKeyListener(this);
        if (Global.NormalFont!=null) setFont(Global.NormalFont);
        if (Global.ControlBackground!=null) setBackground(Global.ControlBackground);
    }
    public ButtonAction (DoActionListener c, String s)
    {   this(c,s,s);
    }
    public void keyPressed (KeyEvent e)
    {   if (e.getKeyCode()==KeyEvent.VK_ENTER)
        {   C.doAction(Name);
        }
    }
    public void keyReleased (KeyEvent e) {}
    public void keyTyped (KeyEvent e) {}
}
